program Lr8;

{$R lr8.res}

uses OWindows, ODialogs, WinTypes, WinProcs, Strings, OStdDlgs;

type
  MainApp=object(TApplication)
    procedure InitMainWindow; virtual;
  end;

  PaintApp=object(TApplication)
    procedure InitMainWindow; virtual;
  end;

  PMainWindow=^TMainWindow;
  TMainWindow=object(TWindow)
    FileName: array[0..12] of Char;
    constructor Init(AParent: PWindowsObject; ATitle: PChar);
    procedure GetWindowClass(var AWndClass: TWndClass); virtual;
    procedure Exit(Msg: TMsg); virtual cm_first+106;
    procedure About(Msg: TMsg); virtual cm_first+107;
    procedure Dialog(Msg: TMsg); virtual cm_first+104;
    procedure Paint(DC:hDC;var Info: TPaintStruct); virtual;
    procedure View(Msg: TMsg); virtual cm_first+101;
    procedure PaintBrush(Msg: TMsg); virtual cm_first+103;
  end;

  PPaintWindow=^TPaintWindow;
  TPaintWindow=object(TWindow)
    ThePen: HPen;
    DragDC: HDC;
    ButtonDown: Boolean;
    constructor Init(AParent: PWindowsObject; ATitle: PChar);
    procedure Exit(Msg: TMsg); virtual id_first+109;
    procedure Paint(DC:hDC;var Info: TPaintStruct); virtual;
    procedure WMLButtonDown(var Msg: TMessage); virtual
              wm_First + wm_LButtonDown;
    procedure WMLButtonUp(var Msg: TMessage); virtual
              wm_First + wm_LButtonUp;
    procedure WMMouseMove(var Msg: TMessage); virtual
              wm_First + wm_MouseMove;
  end;

  PViewDialog=^TViewDialog;
  TViewDialog=object(TWindow)
    constructor Init(AParent: PWindowsObject; AName: PChar);
  end;

procedure TPaintWindow.WMLButtonDown(var Msg: TMessage);
begin
  if not ButtonDown then begin
    ButtonDown := True;
    MoveTo(DragDC, Msg.lParamLo, Msg.lParamHi);
  end;
end;

procedure TPaintWindow.WMLButtonUp(var Msg: TMessage);
begin
  ButtonDown:=False;
end;

procedure TPaintWindow.WMMouseMove(var Msg: TMessage);
  var x, y: Word;
begin
  x:=Msg.lParamLo;
  y:=Msg.lParamHi;
  if ButtonDown then
    if (x>90) and (y>10) and (y<290) and (x<390) then
      LineTo(DragDC, x, y);
end;

constructor TViewDialog.Init(AParent: PWindowsObject; AName: PChar);
begin
  inherited Init(AParent, AName);
  Attr.Style:=WS_CHILD;
end;

procedure MainApp.InitMainWindow;
begin
  MainWindow:=New(PMainWindow, Init(nil, '  8'));
end;

procedure PaintApp.InitMainWindow;
begin
  MainWindow:=New(PPaintWindow, Init(nil, ' '));
end;

procedure TMainWindow.GetWindowClass(var AWndClass: TWndClass);
begin
  TWindow.GetWindowClass(AWndClass);
  AWndClass.hIcon := LoadIcon(HInstance, 'ICON_1');
end;

constructor TMainWindow.Init(AParent: PWindowsObject; ATitle: PChar);
begin
  inherited Init(AParent, ATitle);
  Attr.Style:=WS_SYSMENU+WS_GROUP;
  Attr.W := 320;
  Attr.H := 239;
  Attr.Menu := LoadMenu(HInstance, 'MENU_1');
  StrCopy(FileName, '*.TXT');
end;

constructor TPaintWindow.Init(AParent: PWindowsObject; ATitle: PChar);
  var B: PButton;
begin
  inherited Init(AParent, ATitle);
  Attr.Style:=WS_SYSMENU;
  Attr.W := 400;
  Attr.H := 300;
  B:=New(PButton, Init(@self, 109, '', 10, 10, 70, 50, False));
  ThePen := CreatePen(ps_Solid, 1, 0);
  ButtonDown:=False;
end;

procedure TMainWindow.Exit(Msg: TMsg);
begin
  inherited Done;
end;

procedure TPaintWindow.Exit(Msg: TMsg);
begin
  inherited Done;
end;

procedure TMainWindow.About(Msg: TMsg);
begin
  Application^.ExecDialog(New(PDialog, Init(@self, 'Dialog_2')));
end;

procedure TMainWindow.Dialog(Msg: TMsg);
begin
  Application^.ExecDialog(New(PDialog, Init(@self, 'Dialog_1')));
end;

procedure TMainWindow.View(Msg: TMsg);
  var ViewDlg: PDialog;
      P: PWindow;
      Buf: array[1..255]of Byte;
      F: file;
begin
  if Application^.ExecDialog(New(PFileDialog,
     Init(@Self, PChar(sd_FileOpen), FileName))) = id_Ok
  then if MessageBox(HWindow, FileName, ' :',
       mb_YesNo)=IDYES then begin
    Assign(F, FileName);
    Reset(F);
    BlockRead(F, Buf, 1);

    P := New(PWindow, Init(@self, 'sdasd'));
    P^.Create;
    ViewDlg := New(PDialog, Init(@self, 'DIALOG_3'));
    ViewDlg^.TransferBuffer := @Buf;
    Application^.ExecDialog(ViewDlg);

    Close(F);
  end;
end;

procedure TMainWindow.PaintBrush(Msg: TMsg);
begin
  WinExec('Paint.exe', sw_Show);
end;

procedure TMainWindow.Paint(DC:hDC;var Info: TPaintStruct);
  var
    MemDC:hDC;
    BM:hBitMap;
begin
  BM:=LoadBitMap(hInstance, 'BITMAP_1');
  MemDC:=CreateCompatibleDC(DC);
  SelectObject(MemDC, BM);
  BitBlt(DC, 0, 0, 320, 240, MemDC, 0, 0, SrcCopy);
  DeleteDC(MemDC);
  DeleteObject(BM);
end;

procedure TPaintWindow.Paint(DC:hDC;var Info: TPaintStruct);
begin
  DragDC := GetDC(HWindow);
  SelectObject(DragDC, ThePen);
  Rectangle(DragDC, 90, 10, 390, 270);
end;

var App: MainApp;

begin
  App.Init('');
  App.Run;
  App.Done;
end.
