program Paint;

uses OWindows, ODialogs, WinTypes, WinProcs, Strings, OStdDlgs;

type
  PaintApp=object(TApplication)
    procedure InitMainWindow; virtual;
  end;

  PPaintWindow=^TPaintWindow;
  TPaintWindow=object(TWindow)
    ThePen: HPen;
    DragDC: HDC;
    ButtonDown: Boolean;
    constructor Init(AParent: PWindowsObject; ATitle: PChar);
    procedure Exit(Msg: TMsg); virtual id_first+109;
    procedure Paint(DC:hDC;var Info: TPaintStruct); virtual;
    procedure WMLButtonDown(var Msg: TMessage); virtual
              wm_First + wm_LButtonDown;
    procedure WMLButtonUp(var Msg: TMessage); virtual
              wm_First + wm_LButtonUp;
    procedure WMMouseMove(var Msg: TMessage); virtual
              wm_First + wm_MouseMove;
  end;

procedure TPaintWindow.WMLButtonDown(var Msg: TMessage);
begin
  if not ButtonDown then begin
    ButtonDown := True;
    MoveTo(DragDC, Msg.lParamLo, Msg.lParamHi);
  end;
end;

procedure TPaintWindow.WMLButtonUp(var Msg: TMessage);
begin
  ButtonDown:=False;
end;

procedure TPaintWindow.WMMouseMove(var Msg: TMessage);
  var x, y: Word;
begin
  x:=Msg.lParamLo;
  y:=Msg.lParamHi;
  if ButtonDown then
    if (x>90) and (y>10) and (y<290) and (x<390) then
      LineTo(DragDC, x, y);
end;

procedure PaintApp.InitMainWindow;
begin
  MainWindow:=New(PPaintWindow, Init(nil, ' '));
end;

constructor TPaintWindow.Init(AParent: PWindowsObject; ATitle: PChar);
  var B: PButton;
begin
  inherited Init(AParent, ATitle);
  Attr.Style:=WS_SYSMENU;
  Attr.W := 400;
  Attr.H := 300;
  B:=New(PButton, Init(@self, 109, '', 10, 10, 70, 50, False));
  ThePen := CreatePen(ps_Solid, 1, 0);
  ButtonDown:=False;
end;

procedure TPaintWindow.Exit(Msg: TMsg);
begin
  inherited Done;
end;

procedure TPaintWindow.Paint(DC:hDC;var Info: TPaintStruct);
begin
  DragDC := GetDC(HWindow);
  SelectObject(DragDC, ThePen);
  Rectangle(DragDC, 90, 10, 390, 270);
end;

var App: PaintApp;

begin
  App.Init('');
  App.Run;
  App.Done;
end.
